      SUBROUTINE FIELC(inct,x1,x2,x3,v1,v2,v3,a1,a2,a3)
* on input, x contains the current position, v the velocity, t time
* on output, a returns the acceleration in Lorentz equation
* employs MKS units
      implicit none
      double precision tinput,x1,x2,x3,v1,v2,v3,a1,a2,a3,E(3),B(3),F(3)
     & ,qoverm,gamma,speed,c,vE,lambda,inct,t,pi
      common/currenttime/tinput
      pi=3.14159265d0
      t=tinput+inct
* speed of light
      c=3d8
* electron's charge/mass ratio:
      qoverm=1.6d-19/9.1d-31
* modulus of velocity and relativistic factor
      speed=dsqrt(v1**2+v2**2+v3**2)
      gamma=1d0/dsqrt(1d0-speed**2/c**2)

* Electromagnetic field due to a plane wave propagating along z
* with E along x, B along y
* wavelength:
      lambda = 0.01d0
* Electric field:
      E(1) = 1d7*dcos(2.d0*pi*(c*t-x3)/lambda)
      E(2) = 0d0
      E(3) = 0d0
* Magnetic field
      B(1) = 0d0
      B(2) = E(1)/c
      B(3) = 0d0
* Now we add (or not) a constant magnetic field syncronous with the wave
      B(3) = B(3) + (2.d0*pi*c/lambda)/qoverm
* scalar product of v and E
      vE=v1*E(1)+v2*E(2)+v3*E(3)
* Relativistic acceleration
      F(1)=E(1) + (v2*B(3)-v3*B(2)) - vE*v1/c**2
      F(2)=E(2) + (v3*B(1)-v1*B(3)) - vE*v2/c**2
      F(3)=E(3) + (v1*B(2)-v2*B(1)) - vE*v3/c**2
      a1=F(1)*qoverm/gamma
      a2=F(2)*qoverm/gamma
      a3=F(3)*qoverm/gamma
      return
      end

      SUBROUTINE INIT_COND()
      implicit none
      double precision x1,x2,x3,v1,v2,v3,a1,a2,a3,t,epsa,epsi(6),accur
      common /bas/x1,x2,x3,v1,v2,v3,a1,a2,a3,t,epsa,epsi,accur
      t=0d0
      x1=0d0
      x2=0d0
      x3=0d0
      v1=0d0
      v2=0d0
      v3=0d0
      a1=0d0
      a2=0d0
      a3=0d0
      return
      end
