      SUBROUTINE FIELC(inct,x1,x2,x3,v1,v2,v3,a1,a2,a3)
* on input, x contains the current position, v the velocity, t time
* on output, a returns the acceleration in Lorentz equation
* employs MKS units
      implicit none
      double precision tinput,x1,x2,x3,v1,v2,v3,a1,a2,a3,E(3),B(3),F(3)
     & ,qoverm,gamma,speed,c,vE,inct,t,pi,vtheta(3),vr(3),Br,Btheta,r,
     & costheta,sentheta,mu0,Mdip
      common/currenttime/tinput
      pi=3.14159265d0
      t=tinput+inct
* speed of light
      c=3d8
* electron's charge/mass ratio:
      qoverm=1.6d-19/9.1d-31
* modulus of velocity and relativistic factor
      speed=dsqrt(v1**2+v2**2+v3**2)
      gamma=1d0/dsqrt(1d0-speed**2/c**2)
* Magnetic field associated with the Earth's dipole
      Mdip=7.5d22
      mu0=1.2566d-6
* Electric field: now a circularly instead of linearly polarized wave
      E(1) = 0d0
      E(2) = 0d0
      E(3) = 0d0
* Magnetic field in polar coordinates, then to Cartesian
      r=dsqrt(x1**2+x2**2+x3**2)
      costheta=x3/r
      sentheta=dsqrt(x1**2+x2**2)/r
      Br=mu0*Mdip/(4d0*pi)*2d0*costheta/r**3
      Btheta=mu0*Mdip/(4d0*pi)*sentheta/r**3
      vr(1)=x1/r
      vr(2)=x2/r
      vr(3)=x3/r
      vtheta(1)=x1*x3/(r*dsqrt(x1**2+x2**2))
      vtheta(2)=x2*x3/(r*dsqrt(x1**2+x2**2))
      vtheta(3)=-dsqrt(x1**2+x2**2)/r
      B(1) = Br*vr(1) + Btheta*vtheta(1)
      B(2) = Br*vr(2) + Btheta*vtheta(2)
      B(3) = Br*vr(3) + Btheta*vtheta(3)
* scalar product of v and E
      vE=v1*E(1)+v2*E(2)+v3*E(3)
* Relativistic acceleration
      F(1)=E(1) + (v2*B(3)-v3*B(2)) - vE*v1/c**2
      F(2)=E(2) + (v3*B(1)-v1*B(3)) - vE*v2/c**2
      F(3)=E(3) + (v1*B(2)-v2*B(1)) - vE*v3/c**2
      a1=F(1)*qoverm/gamma
      a2=F(2)*qoverm/gamma
      a3=F(3)*qoverm/gamma
      return
      end

      SUBROUTINE INIT_COND()
      implicit none
      double precision x1,x2,x3,v1,v2,v3,a1,a2,a3,t,epsa,epsi(6),accur
      common /bas/x1,x2,x3,v1,v2,v3,a1,a2,a3,t,epsa,epsi,accur
      t=0d0
* A particle comes almost tangentially into the field on the equatorial 
* plane moving northwards
      x1=2.d7
      x2=0d0
      x3=0d0
      v1=-1d5
      v2=0d0
      v3=1d7
*Or: A particle comes in tangentially near the north pole 
c      x1=2d6
c      x2=0d0
c      x3=8d6
c      v1=-1d7
c      v2=0d0
c      v3=0d0

      a1=0d0
      a2=0d0
      a3=0d0
      return
      end
