
      Program TRAJINT
      Implicit double precision(a-h,p-z)
      parameter(maxit=6000)
      double precision tray(7)
C     ------------------------------------------------------------
C     ELECTRON  TRAJECTORY  INTEGRATION:
C     control del paso y del final de la integracion
C     ------------------------------------------------------------
      common /bas/x1,x2,x3,v1,v2,v3,a1,a2,a3,dt,epsa,epsi(6),accur
      common/currenttime/t
*Se llama a la rutina que provee las condiciones iniciales en t=0
      CALL INIT_COND()
      t=0d0

c     Parametros de control de la precision
      accur=1.d-7	!hay que definirlo para cada problema
      epsa=1.d0   !varia todas las precisiones a la vez(puede quitarse) 
c	Intervalo de tiempo de integracion
      dt=1.d-12
   
      epsi(1)=(dabs(x1)+1.d-2)*accur
      epsi(2)=(dabs(x2)+1.d-2)*accur
      epsi(3)=(dabs(x3)+1d-2)*accur
      epsi(4)=(dabs(v1)+1.D8)*accur
      epsi(5)=(dabs(v2)+1.D8)*accur
      epsi(6)=(dabs(v3)+1.d8)*accur
* Velocity plot:     
      open(unit= 5,file='trayectoria')
* Energy/mass versus distance plot:
      open(unit=7,file='energy_distance')
C     ----------------------------------
C     TRAJECTORY INTEGRATION. STEP T.
C     ----------------------------------
      do IT=1, maxit
       call dorpri
       t=t+dt
       tray(1)=t
       tray(2)=x1
       tray(3)=x2
       tray(4)=x3
       tray(5)=v1/3d8
       tray(6)=v2/3d8
       tray(7)=v3/3d8
       if(AINT(dble(IT)/10d0).eq.dble(IT)/10d0) then
         write(5,*) real(tray(1)),real(tray(5)),real(tray(6)),
     &   real(tray(7))
         write(7,*) real(tray(4)),  
     &   real(1d0/dsqrt(1d0-(v1**2+v2**2+v3**2)/3d8**2))
       endif
       enddo
	  
       close(5)
       close(7)      
       End 

C     ---------------------------------------------------------------
      SUBROUTINE DORPRI
C     ------------------------------------------------------------
C     ELECTRON  TRAJECTORY  INTEGRATION:
C     method=1 => Dormand Prince
C     ------------------------------------------------------------
      Implicit double precision(a-h,p-z)
      common /bas/x1,x2,x3,v1,v2,v3,a1,a2,a3,t,epsa,epsi(6),accur

      save
      data c21,c22,c31,c32,c33,c41,c42,c43,c44,c51,c52,c53
     &    ,c54,c55,q1,q2,q3,q4,q5,d1,d2,d3,d4,d5,d6
     &   /.7500000000000000D-01,    .2250000000000000D+00,
     &    .9777777777777777D+00,    .3733333333333333D+01,
     &    .3555555555555555D+01,    .2952598689224204D+01,
     &    .1159579332418839D+02,    .9822892851699436D+01,
     &    .2908093278463649D+00,    .2846275252525253D+01,
     &    .1075757575757576D+02,    .8906422717743473D+01,
     &    .2784090909090909D+00,    .2735313036020583D+00,
     &    .9114583333333333D-01,    .4492362982929021D+00,
     &    .6510416666666666D+00,    .3223761792452830D+00,
     &    .1309523809523810D+00,    .1232638888888889D-02,
     &    .4252770290506139D-02,    .3697916666666667D-01,
     &    .5086379716981132D-01,    .4190476190476190D-01,
     &    .2500000000000000D-01/

 10      x11=x1+0.2d0*v1*t
	 x21=x2+0.2d0*v2*t
	 x31=x3+0.2d0*v3*t

         v11=v1+.2d0*a1*t
         v21=v2+.2d0*a2*t
         v31=v3+.2d0*a3*t

c	Llama a la subrutina que calcula el campo, 
c       devuelve las componentes de la aceleracion
        passt=0.d0
	 CALL FIELC(passt,X11,X21,X31,v11,v21,v31,a11,a21,a31)

	 x12=x1+(c21*v1+c22*v11)*t
	 x22=x2+(c21*v2+c22*v21)*t 
	 x32=x3+(c21*v3+c22*v31)*t

 
         v12=v1+(c21*a1+c22*a11)*t
         v22=v2+(c21*a2+c22*a21)*t
         v32=v3+(c21*a3+c22*a31)*t

         passt=t/5d0
	 CALL FIELC(passt,X12,X22,X32,v12,v22,v32,a12,a22,a32)


	 x13=x1+(c31*v1-c32*v11+c33*v12)*t 
	 x23=x2+(c31*v2-c32*v21+c33*v22)*t
	 x33=x3+(c31*v3-c32*v31+c33*v32)*t

         v13=v1+(c31*a1-c32*a11+c33*a12)*t
         v23=v2+(c31*a2-c32*a21+c33*a22)*t
         v33=v3+(c31*a3-c32*a31+c33*a32)*t

         passt=t*3d0/10d0
	 CALL FIELC(passt,X13,X23,X33,v13,v23,v33,A13,A23,a33)

	 x14=x1+(c41*v1-c42*v11+c43*v12-c44*v13)*t
	 x24=x2+(c41*v2-c42*v21+c43*v22-c44*v23)*t 
	 x34=x3+(c41*v3-c42*v31+c43*v32-c44*v33)*t 


         v14=v1+(c41*a1-c42*a11+c43*a12-c44*a13)*t
         v24=v2+(c41*a2-c42*a21+c43*a22-c44*a23)*t
         v34=v3+(c41*a3-c42*a31+c43*a32-c44*a33)*t

         passt=t*4d0/5d0
	 CALL FIELC(passt,X14,X24,X34,v14,v24,v34,A14,A24,a34)

	 x15=x1+(c51*v1-c52*v11+c53*v12+c54*v13-c55*v14)*t
	 x25=x2+(c51*v2-c52*v21+c53*v22+c54*v23-c55*v24)*t   
	 x35=x3+(c51*v3-c52*v31+c53*v32+c54*v33-c55*v34)*t   

         v15=v1+(c51*a1-c52*a11+c53*a12+c54*a13-c55*a14)*t
         v25=v2+(c51*a2-c52*a21+c53*a22+c54*a23-c55*a24)*t
         v35=v3+(c51*a3-c52*a31+c53*a32+c54*a33-c55*a34)*t

         passt=t*8d0/9d0
	 CALL FIELC(passt,X15,X25,X35,v15,v25,v35,A15,A25,a35)
	 
	 v1p=v1+(q1*a1+q2*a12+q3*a13-q4*a14+q5*a15)*t
	 v2p=v2+(q1*a2+q2*a22+q3*a23-q4*a24+q5*a25)*t
	 v3p=v3+(q1*a3+q2*a32+q3*a33-q4*a34+q5*a35)*t
	 
	 x1p=x1+(q1*v1+q2*v12+q3*v13-q4*v14+q5*v15)*t
	 x2p=x2+(q1*v2+q2*v22+q3*v23-q4*v24+q5*v25)*t 
	 x3p=x3+(q1*v3+q2*v32+q3*v33-q4*v34+q5*v35)*t          

         passt=t
	 CALL FIELC(passt,X1P,X2P,X3P,v1p,v2p,v3p,A1P,A2P,a3p)


c      ---------------------------------------------------
c       Error terms
c      ---------------------------------------------------
	 dv1=(d1*a1-d2*a12+d3*a13-d4*a14+d5*a15-d6*a1p)*t
	 dv2=(d1*a2-d2*a22+d3*a23-d4*a24+d5*a25-d6*a2p)*t
	 dv3=(d1*a3-d2*a32+d3*a33-d4*a34+d5*a35-d6*a3p)*t
	 dx1=(d1*v1-d2*v12+d3*v13-d4*v14+d5*v15-d6*v1p)*t
	 dx2=(d1*v2-d2*v22+d3*v23-d4*v24+d5*v25-d6*v2p)*t
	 dx3=(d1*v3-d2*v32+d3*v33-d4*v34+d5*v35-d6*v3p)*t

	 dx1=abs(dx1/epsi(1))
	 dx2=abs(dx2/epsi(2))
	 dx3=abs(dx3/epsi(3))
	 dv1=abs(dv1/epsi(4))
	 dv2=abs(dv2/epsi(5))
	 dv3=abs(dv3/epsi(6))
	 dmax=epsa/dmax1(dx1,dx2,dx3,dv1,dv2,dv3)

c       ---------------------------------------------------             
c       Computation of the step size
c       ---------------------------------------------------
	     t=0.9d0*t*dmax**.2d0
	     if(dmax.lt.1d0) go to 10
* Si el error es demasiado grande, recalcular con un paso mas chico
	     
	    

c     Valores obtenidos al final del proceso
         a1=a1p
	 a2=a2p
	 a3=a3p
	 v1=v1p
	 v2=v2p
	 v3=v3p
	 x1=x1p
	 x2=x2p
	 x3=x3p
 
      Return
      End
